Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class MappingIterator

    java.lang.Object
      net.sf.saxon.expr.MappingIterator

All Implemented Interfaces:
  AtomizableIterator, SequenceIterator

public final class MappingIterator
extends java.lang.Object
implements SequenceIterator, AtomizableIterator

MappingIterator merges a sequence of sequences into a single flat sequence. It takes as inputs an iteration, and a mapping function to be applied to each Item returned by that iteration. The mapping function itself returns another iteration. The result is an iteration of the concatenation of all the iterations returned by the mapping function.

This is a powerful class. It is used, with different mapping functions, in a great variety of ways. It underpins the way that "for" expressions and path expressions are evaluated, as well as sequence expressions. It is also used in the implementation of the document(), key(), and id() functions.

Constructor Summary
`MappingIterator(SequenceIterator base, MappingFunction action, XPathContext context, java.lang.Object info)` Construct a MappingIterator that will apply a specified MappingFunction to each Item returned by the base iterator.

Method Summary
`Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`Item` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position.
`void` | `setIsAtomizing(boolean atomizing)` Indicate that any nodes returned in the sequence will be atomized.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MappingIterator

    public MappingIterator(SequenceIterator base,
                           MappingFunction action,
                           XPathContext context,
                           java.lang.Object info)

  Construct a MappingIterator that will apply a specified MappingFunction to each Item returned by the base iterator.

Parameters:
  `base` - the base iterator
  `action` - the mapping function to be applied
  `context` - the processing context. This should be supplied only if each item to be processed is to become the context item. In this case "base" should be the same as context.getCurrentIterator().
  `info` - an arbitrary object to be passed as a parameter to the mapping function each time it is called

Method Detail

### next

    public Item next()
              throws XPathException

  Description copied from interface: `SequenceIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Description copied from interface: `SequenceIterator`
  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next().

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(); or null, if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Description copied from interface: `SequenceIterator`
  Get the current position. This will be zero before the first call on next(), otherwise it will be the number of times that next() has been called.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next()

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Description copied from interface: `SequenceIterator`
  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs

### setIsAtomizing

    public void setIsAtomizing(boolean atomizing)

  Indicate that any nodes returned in the sequence will be atomized. This means that if it wishes to do so, the implementation can return the typed values of the nodes rather than the nodes themselves. The implementation is free to ignore this hint.

  Specified by:
    `setIsAtomizing` in interface `AtomizableIterator`
  Parameters:
    `atomizing` - true if the caller of this iterator will atomize any nodes that are returned, and is therefore willing to accept the typed value of the nodes instead of the nodes themselves.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD